-
AI-powered Extensions
-
Data Grid
-
Tree List
-
Chat
-
HTML Editor
-
Form
-
-
Data Grids / Data Management
-
Data Grid
- Overview
-
Data Binding
-
Filtering
- Sorting
-
Editing
-
Grouping
-
Selection
- Focused Row
- Paging
-
Scrolling
-
Columns
- AI Assistant
-
Master-Detail
-
Data Summaries
-
Drag & Drop
-
Export to PDF
-
Export to Excel
- Appearance
-
Customization
- State Persistence
-
Adaptability
-
Keyboard Navigation
- Right-To-Left Support
-
Tree List
- Overview
-
Data Binding
-
Filtering
- Sorting
-
Editing
-
Selection
- Focused Row
- Paging
-
Columns
- Drag & Drop
- State Persistence
- Adaptability
-
Keyboard Navigation
-
Card View
-
Pivot Grid
- Overview
-
Data Binding
-
Field Management
-
Data Summaries
- Drill Down
- Filtering
-
Scrolling
-
Export to Excel
- Chart Integration
- Customization
- State Persistence
-
Filter Builder
-
-
Data Visualization
-
Charts
- Overview
-
Data Binding
-
Common Concepts
-
Axis
-
Aggregation
-
Tooltips
-
Selection
-
Customization
-
Zooming
-
Export
-
-
Area Charts
-
Bar Charts
- Bullet Charts
-
Doughnut Charts
-
Financial Charts
-
Funnel and Pyramid Charts
-
Line Charts
- Pareto Chart
-
Pie Charts
-
Point Charts
-
Polar and Radar Charts
-
Range Charts
- Sankey Chart
-
Sparkline Charts
-
Tree Map
-
Gauges
- Overview
-
Runtime update
-
Bar Gauge
-
Circular Gauge
-
Linear Gauge
-
Diagram
- Overview
-
Data Binding
-
Featured Shapes
-
Custom Shapes
-
Document Capabilities
-
User Interaction
- UI Customization
- Adaptability
-
-
Scheduling / Planning
-
Scheduler
- Overview
-
Data Binding
-
Views
-
Appointments
-
Timetable
- Editing
-
Grouping
- Virtual Scrolling
- Drag & Drop
-
Customization
- Adaptability
-
Gantt
- Overview
- Data Binding
-
Filtering
- Sorting
- Strip Lines
- Export to PDF
- Validation
-
Customization
-
-
Messaging
-
WYSIWYG Editor
-
Forms
-
Data Editors
- Overview
-
Common Concepts
-
Calendar
- Check Box
- Color Box
-
Date Box
-
Date Range Box
-
Number Box
- Radio Group
-
Range Selector
- Range Slider
- Slider
- Switch
- Text Area
- Text Box
-
Drop-Downs
- Autocomplete
-
Drop Down Box
-
Select Box
-
Tag Box
-
Lookup
-
Buttons
-
File Upload / File Management
-
File Manager
- Overview
-
File System Types
-
Customization
-
File Uploader
-
-
Popup and Notifications
-
Navigation
- Overview
- Accordion
-
Action Sheet
-
Context Menu
-
Menu
- Multi View
-
Drawer
-
Tab Panel
-
Tabs
-
Toolbar
-
Stepper
- Pagination
-
List
-
Tree View
- Right-to-Left Support
-
Layout
-
Interactive Wrappers
-
Sortable
- Resizable
-
-
Progress Indicators
-
Maps
- Overview
-
Map
-
Vector Map
-
Data Binding
- Multiple Layers
-
Markers
- Legend
-
Zooming and Panning
-
Customization
-
-
Localization
Related Demos:
Your search did not match any results.
JavaScript/jQuery Form - Item Customization
Backend API
$(() => {
$('#form').dxForm({
formData: employee,
items: [{
itemType: 'group',
caption: 'Employee Details',
colCount: 2,
items: [{
dataField: 'FirstName',
editorOptions: {
disabled: true,
},
label: {
template: labelTemplate('user'),
},
}, {
dataField: 'Position',
editorType: 'dxSelectBox',
editorOptions: {
items: positions,
searchEnabled: true,
value: '',
},
validationRules: [{
type: 'required',
message: 'Position is required',
}],
label: {
template: labelTemplate('info'),
},
}, {
dataField: 'LastName',
editorOptions: {
disabled: true,
},
label: {
template: labelTemplate('user'),
},
}, {
dataField: 'HireDate',
editorType: 'dxDateBox',
editorOptions: {
value: null,
width: '100%',
},
validationRules: [{
type: 'required',
message: 'Hire date is required',
}],
label: {
template: labelTemplate('event'),
},
}, {
dataField: 'BirthDate',
editorType: 'dxDateBox',
editorOptions: {
disabled: true,
width: '100%',
},
label: {
template: labelTemplate('event'),
},
}, {
dataField: 'Address',
label: {
template: labelTemplate('home'),
},
}, {
colSpan: 2,
dataField: 'Notes',
editorType: 'dxTextArea',
editorOptions: {
height: 90,
maxLength: 200,
},
label: {
template: (data, element) => {
const lineBreak = '<br>';
const infoIcon = '<i id="helpedInfo" class="dx-icon dx-icon-info"></i>';
const labelText = `Additional${lineBreak}${data.text}`;
element.append(`<div id='template-content'>${infoIcon}${labelText}</div>`);
$('<div>').dxTooltip({
target: '#helpedInfo',
showEvent: 'mouseenter',
hideEvent: 'mouseleave',
contentTemplate(args) {
args.html('<div id="tooltip-content">This field must not exceed 200 characters</div>');
},
}).appendTo(element);
},
},
}, {
dataField: 'Phone',
editorOptions: {
mask: '(X00) 000-0000',
maskRules: { X: /[02-9]/ },
},
label: {
template: labelTemplate('tel'),
},
}, {
dataField: 'Email',
label: {
template: labelTemplate('email'),
},
}],
}],
});
$('#form').dxForm('instance').validate();
function labelTemplate(iconName) {
return (data) => $(`<div><i class='dx-icon dx-icon-${iconName}'></i>${data.text}</div>`);
}
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script>
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.8/css/dx.light.css" />
<script src="js/dx.all.js?v=25.2.8"></script>
<script src="data.js"></script>
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="index.js"></script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="form"></div>
</div>
</body>
</html>
#helpedInfo {
color: #42a5f5;
}
#tooltip-content {
font-size: 14px;
font-weight: bold;
}
#template-content {
display: inline-flex;
}
const employee = {
ID: 1,
FirstName: 'John',
LastName: 'Heart',
Position: 'CEO',
BirthDate: '1964/03/16',
HireDate: '1995/01/15',
Notes: 'John has been in the Audio/Video industry since 1990. He has led DevAv as its CEO since 2003.\r\n\r\nWhen not working hard as the CEO, John loves to golf and bowl. He once bowled a perfect game of 300.',
Address: '351 S Hill St., Los Angeles, CA',
Phone: '360-684-1334',
Email: 'jheart@dx-email.com',
};
const positions = [
'HR Manager',
'IT Manager',
'CEO',
'Controller',
'Sales Manager',
'Support Manager',
'Shipping Manager',
];
To change the default settings, declare an item configuration object. Use the dataField property to bind an item to a field in the formData object. Use the editorType property to specify an item's data editor or configure the editor in the editorOptions object. You can also specify any other properties described in the SimpleItem section.
To customize item labels, use the label.template property. The demo uses this property to add icons to the labels. Refer to the Additional Notes item's implementation for instructions on how to add an icon with a tooltip to the label.
This demo shows how to specify editorOptions, editorType, validationRules, and colSpan properties for simple items in a JavaScript Form component.

DevExtreme v25.1 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.

React Form - Item Customization

You can use the items[] array to configure all form items. This array can contain strings (formData field names) and objects (item configurations).

Use a string to create a simple item with default configuration as shown for the Email item.

Backend API
import React, { useCallback } from 'react'; import { ValidationRule } from 'devextreme-react/common'; import { Form, Item, GroupItem, Label, type FormTypes, } from 'devextreme-react/form'; import 'devextreme-react/text-area'; import service from './data.ts'; import LabelTemplate from './LabelTemplate.tsx'; import LabelNotesTemplate from './LabelNotesTemplate.tsx'; const employee = service.getEmployee(); const validationRules: { position: ValidationRule[], hireDate: ValidationRule[] } = { position: [ { type: 'required', message: 'Position is required.' }, ], hireDate: [ { type: 'required', message: 'Hire Date is required.' }, ], }; const nameEditorOptions = { disabled: true }; const positionEditorOptions = { items: service.getPositions(), searchEnabled: true, value: '' }; const hireDateEditorOptions = { width: '100%', value: null }; const birthDateEditorOptions = { width: '100%', disabled: true }; const notesEditorOptions = { height: 90, maxLength: 200 }; const phoneEditorOptions = { mask: '+1 (X00) 000-0000', maskRules: { X: /[02-9]/ } }; const App = () => { const validateForm = useCallback((e: FormTypes.ContentReadyEvent) => { e.component.validate(); }, []); return ( <Form onContentReady={validateForm} formData={employee}> <GroupItem colCount={2} caption="Employee Details"> <Item dataField="FirstName" editorOptions={nameEditorOptions}> <Label render={LabelTemplate('user')} /> </Item> <Item dataField="Position" editorType="dxSelectBox" editorOptions={positionEditorOptions} validationRules={validationRules.position}> <Label render={LabelTemplate('info')} /> </Item> <Item dataField="LastName" editorOptions={nameEditorOptions}> <Label render={LabelTemplate('user')} /> </Item> <Item dataField="HireDate" editorType="dxDateBox" editorOptions={hireDateEditorOptions} validationRules={validationRules.hireDate}> <Label render={LabelTemplate('event')} /> </Item> <Item dataField="BirthDate" editorType="dxDateBox" editorOptions={birthDateEditorOptions}> <Label render={LabelTemplate('event')} /> </Item> <Item dataField="Address"> <Label render={LabelTemplate('home')} /> </Item> <Item dataField="Notes" colSpan={2} editorType="dxTextArea" editorOptions={notesEditorOptions}> <Label render={LabelNotesTemplate} /> </Item> <Item dataField="Phone" editorOptions={phoneEditorOptions}> <Label render={LabelTemplate('tel')} /> </Item> <Item dataField="Email"> <Label render={LabelTemplate('email')} /> </Item> </GroupItem> </Form> ); }; export default App;
import React, { useCallback } from 'react'; import { Form, Item, GroupItem, Label, } from 'devextreme-react/form'; import 'devextreme-react/text-area'; import service from './data.js'; import LabelTemplate from './LabelTemplate.js'; import LabelNotesTemplate from './LabelNotesTemplate.js'; const employee = service.getEmployee(); const validationRules = { position: [{ type: 'required', message: 'Position is required.' }], hireDate: [{ type: 'required', message: 'Hire Date is required.' }], }; const nameEditorOptions = { disabled: true }; const positionEditorOptions = { items: service.getPositions(), searchEnabled: true, value: '' }; const hireDateEditorOptions = { width: '100%', value: null }; const birthDateEditorOptions = { width: '100%', disabled: true }; const notesEditorOptions = { height: 90, maxLength: 200 }; const phoneEditorOptions = { mask: '+1 (X00) 000-0000', maskRules: { X: /[02-9]/ } }; const App = () => { const validateForm = useCallback((e) => { e.component.validate(); }, []); return ( <Form onContentReady={validateForm} formData={employee} > <GroupItem colCount={2} caption="Employee Details" > <Item dataField="FirstName" editorOptions={nameEditorOptions} > <Label render={LabelTemplate('user')} /> </Item> <Item dataField="Position" editorType="dxSelectBox" editorOptions={positionEditorOptions} validationRules={validationRules.position} > <Label render={LabelTemplate('info')} /> </Item> <Item dataField="LastName" editorOptions={nameEditorOptions} > <Label render={LabelTemplate('user')} /> </Item> <Item dataField="HireDate" editorType="dxDateBox" editorOptions={hireDateEditorOptions} validationRules={validationRules.hireDate} > <Label render={LabelTemplate('event')} /> </Item> <Item dataField="BirthDate" editorType="dxDateBox" editorOptions={birthDateEditorOptions} > <Label render={LabelTemplate('event')} /> </Item> <Item dataField="Address"> <Label render={LabelTemplate('home')} /> </Item> <Item dataField="Notes" colSpan={2} editorType="dxTextArea" editorOptions={notesEditorOptions} > <Label render={LabelNotesTemplate} /> </Item> <Item dataField="Phone" editorOptions={phoneEditorOptions} > <Label render={LabelTemplate('tel')} /> </Item> <Item dataField="Email"> <Label render={LabelTemplate('email')} /> </Item> </GroupItem> </Form> ); }; export default App;
import React from 'react'; import { Tooltip } from 'devextreme-react/tooltip'; function LabelNotesTemplate(data) { return ( <React.Fragment> <div id="template-content"> <i id="helpedInfo" className="dx-icon dx-icon-info"></i> Additional <br /> { data.text } </div> <Tooltip target="#helpedInfo" showEvent="mouseenter" hideEvent="mouseleave" > <div id="tooltip-content">This field must not exceed 200 characters</div> </Tooltip> </React.Fragment> ); } export default LabelNotesTemplate;
import React from 'react'; export default function LabelTemplate(iconName: string) { return function template(data) { return (<div><i className={`dx-icon dx-icon-${iconName}`}></i>{ data.text }</div>); }; }
import React from 'react'; import ReactDOM from 'react-dom'; import App from './App.tsx'; ReactDOM.render( <App />, document.getElementById('app'), );
const employee = { ID: 1, FirstName: 'John', LastName: 'Heart', Position: 'CEO', BirthDate: '1964/03/16', HireDate: '1995/01/15', Notes: 'John has been in the Audio/Video industry since 1990. He has led DevAv as its CEO since 2003.\r\n\r\nWhen not working hard as the CEO, John loves to golf and bowl. He once bowled a perfect game of 300.', Address: '351 S Hill St., Los Angeles, CA', Phone: '360-684-1334', Email: 'jheart@dx-email.com', }; const positions = [ 'HR Manager', 'IT Manager', 'CEO', 'Controller', 'Sales Manager', 'Support Manager', 'Shipping Manager', ]; export default { getEmployee() { return employee; }, getPositions() { return positions; }, };
window.exports = window.exports || {}; window.config = { transpiler: 'ts', typescriptOptions: { module: 'system', emitDecoratorMetadata: true, experimentalDecorators: true, jsx: 'react', }, meta: { 'react': { 'esModule': true, }, 'typescript': { 'exports': 'ts', }, 'devextreme/time_zone_utils.js': { 'esModule': true, }, 'devextreme/localization.js': { 'esModule': true, }, 'devextreme/viz/palette.js': { 'esModule': true, }, 'openai': { 'esModule': true, }, }, paths: { 'npm:': 'https://cdn.jsdelivr.net/npm/', 'bundles:': '../../../../bundles/', 'externals:': '../../../../bundles/externals/', }, defaultExtension: 'js', map: { 'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js', 'typescript': 'npm:typescript@4.2.4/lib/typescript.js', 'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js', 'react': 'npm:react@17.0.2/umd/react.development.js', 'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js', 'prop-types': 'npm:prop-types/prop-types.js', 'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js', 'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js', 'es6-object-assign': 'npm:es6-object-assign', 'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs', 'devextreme-react': 'npm:devextreme-react@link:../../packages/devextreme-react/npm/cjs', 'devextreme-quill': 'npm:devextreme-quill@1.7.5/dist/dx-quill.min.js', 'devexpress-diagram': 'npm:devexpress-diagram@2.2.24/dist/dx-diagram.js', 'devexpress-gantt': 'npm:devexpress-gantt@4.1.64/dist/dx-gantt.js', 'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js', 'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js', 'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js', 'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js', 'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js', 'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js', 'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js', 'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js', '@preact/signals-core': 'npm:@preact/signals-core@1.8.0/dist/signals-core.min.js', 'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3', // SystemJS plugins 'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js', 'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js', // Prettier 'prettier/standalone': 'npm:prettier@2.8.8/standalone.js', 'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js', }, packages: { 'devextreme': { defaultExtension: 'js', }, 'devextreme-react': { main: 'index.js', }, 'devextreme-react/common': { main: 'index.js', }, 'devextreme/events/utils': { main: 'index', }, 'devextreme/common/core/events/utils': { main: 'index', }, 'devextreme/localization/messages': { format: 'json', defaultExtension: 'json', }, 'devextreme/events': { main: 'index', }, 'es6-object-assign': { main: './index.js', defaultExtension: 'js', }, }, packageConfigPaths: [ 'npm:@devextreme/*/package.json', ], babelOptions: { sourceMaps: false, stage0: true, react: true, }, }; System.config(window.config); // eslint-disable-next-line const useTgzInCSB = ['openai'];
import React from 'react'; import { Tooltip } from 'devextreme-react/tooltip'; function LabelNotesTemplate(data) { return ( <React.Fragment> <div id="template-content"> <i id="helpedInfo" className="dx-icon dx-icon-info" ></i> Additional <br /> {data.text} </div> <Tooltip target="#helpedInfo" showEvent="mouseenter" hideEvent="mouseleave" > <div id="tooltip-content">This field must not exceed 200 characters</div> </Tooltip> </React.Fragment> ); } export default LabelNotesTemplate;
import React from 'react'; export default function LabelTemplate(iconName) { return function template(data) { return ( <div> <i className={`dx-icon dx-icon-${iconName}`}></i> {data.text} </div> ); }; }
import React from 'react'; import ReactDOM from 'react-dom'; import App from './App.js'; ReactDOM.render(<App />, document.getElementById('app'));
const employee = { ID: 1, FirstName: 'John', LastName: 'Heart', Position: 'CEO', BirthDate: '1964/03/16', HireDate: '1995/01/15', Notes: 'John has been in the Audio/Video industry since 1990. He has led DevAv as its CEO since 2003.\r\n\r\nWhen not working hard as the CEO, John loves to golf and bowl. He once bowled a perfect game of 300.', Address: '351 S Hill St., Los Angeles, CA', Phone: '360-684-1334', Email: 'jheart@dx-email.com', }; const positions = [ 'HR Manager', 'IT Manager', 'CEO', 'Controller', 'Sales Manager', 'Support Manager', 'Shipping Manager', ]; export default { getEmployee() { return employee; }, getPositions() { return positions; }, };
<!DOCTYPE html> <html lang="en"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" /> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.1.5/css/dx.light.css" /> <link rel="stylesheet" type="text/css" href="https://maxcdn.bootstrapcdn.com/font-awesome/4.6.3/css/font-awesome.min.css" /> <link rel="stylesheet" type="text/css" href="styles.css" /> <script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script> <script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script> <script type="text/javascript" src="config.js"></script> <script type="text/javascript"> System.import("./index.tsx"); </script> </head> <body class="dx-viewport"> <div class="demo-container"> <div id="app"></div> </div> </body> </html>
#helpedInfo { color: #42a5f5; } #tooltip-content { font-size: 14px; font-weight: bold; } #template-content { display: inline-flex; }

To change the default settings, declare an item configuration object. Use the dataField property to bind an item to a field in the formData object. Use the editorType property to specify an item's data editor or configure the editor in the editorOptions object. You can also specify any other properties described in the SimpleItem section.

To customize item labels, use the label.template property. The demo uses this property to add icons to the labels. Refer to the Additional Notes item's implementation for instructions on how to add an icon with a tooltip to the label.

This demo shows how to specify editorOptions, editorType, validationRules, and colSpan properties for simple items in a Form component.

<div id="form-container">
<dx-form id="form" [formData]="employee">
<dxi-form-item itemType="group" [colCount]="2" caption="Employee Details">
<dxi-form-item dataField="FirstName" [editorOptions]="nameEditorOptions">
<dxo-form-label template="name"></dxo-form-label>
</dxi-form-item>
<dxi-form-item
dataField="Position"
editorType="dxSelectBox"
[editorOptions]="positionEditorOptions"
>
<dxi-form-validation-rule
type="required"
message="Position is required"
></dxi-form-validation-rule>
<dxo-form-label template="position"></dxo-form-label>
</dxi-form-item>
<dxi-form-item dataField="LastName" [editorOptions]="nameEditorOptions">
<dxo-form-label template="name"></dxo-form-label>
</dxi-form-item>
<dxi-form-item
dataField="HireDate"
editorType="dxDateBox"
[editorOptions]="hireDateEditorOptions"
>
<dxi-form-validation-rule
type="required"
message="Hire date is required"
></dxi-form-validation-rule>
<dxo-form-label template="date"></dxo-form-label>
</dxi-form-item>
<dxi-form-item
dataField="BirthDate"
editorType="dxDateBox"
[editorOptions]="birthDateEditorOptions"
>
<dxo-form-label template="date"></dxo-form-label>
</dxi-form-item>
<dxi-form-item dataField="Address">
<dxo-form-label template="address"></dxo-form-label>
</dxi-form-item>
<dxi-form-item
dataField="Notes"
editorType="dxTextArea"
[editorOptions]="notesEditorOptions"
[colSpan]="2"
>
<dxo-form-label template="notes"></dxo-form-label>
</dxi-form-item>
<dxi-form-item dataField="Phone" [editorOptions]="phoneEditorOptions">
<dxo-form-label template="phone"></dxo-form-label>
</dxi-form-item>
<dxi-form-item dataField="Email">
<dxo-form-label template="email"></dxo-form-label>
</dxi-form-item>
</dxi-form-item>
@for (label of labelTemplates; track label.name) {
<ng-container>
<div *dxTemplate="let data of label.name">
<div><i class="dx-icon {{ label.icon }}"></i>{{ data.text }}</div>
</div>
</ng-container>
}
<div *dxTemplate="let data of 'notes'">
<div id="template-content">
<i id="helpedInfo" class="dx-icon dx-icon-info"></i>
Additional
<br />
{{ data.text }}
</div>
<dx-tooltip
target="#helpedInfo"
showEvent="mouseenter"
hideEvent="mouseleave"
>
<div *dxTemplate="let data = data; of: 'content'">
<div id="tooltip-content">
This field must not exceed 200 characters
</div>
</div>
</dx-tooltip>
</div>
</dx-form>
</div>
import { bootstrapApplication } from '@angular/platform-browser';
import {
Component,
ViewChild,
enableProdMode,
AfterViewInit,
provideZoneChangeDetection,
} from '@angular/core';
import {
DxFormModule,
DxFormComponent,
DxTooltipModule,
} from 'devextreme-angular';
import 'devextreme/ui/select_box';
import 'devextreme/ui/text_area';
import { Employee, Service } from './app.service';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
providers: [Service],
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
imports: [
DxFormModule,
DxTooltipModule,
],
})
export class AppComponent implements AfterViewInit {
@ViewChild(DxFormComponent, { static: false }) form: DxFormComponent;
employee: Employee;
positions: string[];
nameEditorOptions: Object;
positionEditorOptions: Object;
validationRules: Object;
hireDateEditorOptions: Object;
birthDateEditorOptions: Object;
notesEditorOptions: Object;
phoneEditorOptions: Object;
labelTemplates: { name: string; icon: string }[];
constructor(service: Service) {
this.employee = service.getEmployee();
this.nameEditorOptions = { disabled: true };
this.positionEditorOptions = { items: service.getPositions(), searchEnabled: true, value: '' };
this.validationRules = {
position: [
{ type: 'required', message: 'Position is required.' },
],
hireDate: [
{ type: 'required', message: 'Hire Date is required.' },
],
};
this.hireDateEditorOptions = { width: '100%', value: null };
this.birthDateEditorOptions = { width: '100%', disabled: true };
this.notesEditorOptions = { height: 90, maxLength: 200 };
this.phoneEditorOptions = { mask: '(X00) 000-0000', maskRules: { X: /[02-9]/ } };
this.labelTemplates = [
{ name: 'name', icon: 'dx-icon-user' },
{ name: 'position', icon: 'dx-icon-info' },
{ name: 'date', icon: 'dx-icon-event' },
{ name: 'address', icon: 'dx-icon-home' },
{ name: 'phone', icon: 'dx-icon-tel' },
{ name: 'email', icon: 'dx-icon-email' },
];
}
ngAfterViewInit() {
this.form.instance.validate();
}
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
],
});
::ng-deep #helpedInfo {
color: #42a5f5;
}
::ng-deep #tooltip-content {
font-size: 14px;
font-weight: bold;
}
::ng-deep #template-content {
display: inline-flex;
}
import { Injectable } from '@angular/core';
export class Employee {
ID: number;
FirstName: string;
LastName: string;
Position: string;
BirthDate: string;
HireDate: string;
Notes: string;
Address: string;
Phone: string;
Email: string;
}
const employee: Employee = {
ID: 1,
FirstName: 'John',
LastName: 'Heart',
Position: 'CEO',
BirthDate: '1964/03/16',
HireDate: '1995/01/15',
Notes: 'John has been in the Audio/Video industry since 1990. He has led DevAv as its CEO since 2003.\r\n\r\nWhen not working hard as the CEO, John loves to golf and bowl. He once bowled a perfect game of 300.',
Address: '351 S Hill St., Los Angeles, CA',
Phone: '360-684-1334',
Email: 'jheart@dx-email.com',
};
const positions: string[] = [
'HR Manager',
'IT Manager',
'CEO',
'Controller',
'Sales Manager',
'Support Manager',
'Shipping Manager',
];
@Injectable()
export class Service {
getEmployee(): Employee {
return employee;
}
getPositions(): string[] {
return positions;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.31',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.70',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.4/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.16.2/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.31/package.json',
'npm:devexpress-gantt@4.1.70/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
},
"@angular/core": {
"version": "22.1.0"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "6.0.3"
},
"zone.js": {
"version": "0.16.2"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.16.2/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>

Your search did not match any results.

Vue Form - Item Customization

You can use the items[] array to configure all form items. This array can contain strings (formData field names) and objects (item configurations).

Use a string to create a simple item with default configuration as shown for the Email item.

Backend API
<template> <DxForm :on-content-ready="validateForm" :form-data="employee" > <DxGroupItem :col-count="2" caption="Employee Details" > <DxItem :editor-options="nameEditorOptions" data-field="FirstName" > <DxLabel template="nameLabel"/> </DxItem> <DxItem :editor-options="positionEditorOptions" :validation-rules="validationRules.position" data-field="Position" editor-type="dxSelectBox" > <DxLabel template="positionLabel"/> </DxItem> <DxItem :editor-options="nameEditorOptions" data-field="LastName" > <DxLabel template="nameLabel"/> </DxItem> <DxItem :editor-options="hireDateEditorOptions" :validation-rules="validationRules.hireDate" data-field="HireDate" editor-type="dxDateBox" > <DxLabel template="dateLabel"/> </DxItem> <DxItem :editor-options="birthDateEditorOptions" data-field="BirthDate" editor-type="dxDateBox" > <DxLabel template="dateLabel"/> </DxItem> <DxItem data-field="Address" > <DxLabel template="addressLabel"/> </DxItem> <DxItem :col-span="2" :editor-options="notesEditorOptions" data-field="Notes" editor-type="dxTextArea" > <DxLabel template="notesLabel"/> </DxItem> <DxItem :editor-options="phoneEditorOptions" data-field="Phone" > <DxLabel template="phoneLabel"/> </DxItem> <DxItem data-field="Email" > <DxLabel template="emailLabel"/> </DxItem> </DxGroupItem> <template #nameLabel="{ data }"> <LabelTemplate :data="data" icon="user" /> </template> <template #positionLabel="{ data }"> <LabelTemplate :data="data" icon="info" /> </template> <template #dateLabel="{ data }"> <LabelTemplate :data="data" icon="event" /> </template> <template #addressLabel="{ data }"> <LabelTemplate :data="data" icon="home" /> </template> <template #notesLabel="{ data }"> <LabelNotesTemplate :data="data" /> </template> <template #phoneLabel="{ data }"> <LabelTemplate :data="data" icon="tel" /> </template> <template #emailLabel="{ data }"> <LabelTemplate :data="data" icon="email" /> </template> </DxForm> </template> <script setup lang="ts"> import { DxForm, DxItem, DxLabel, DxGroupItem, type DxFormTypes, } from 'devextreme-vue/form'; import { type ValidationRule } from 'devextreme-vue/common'; import service from './data.ts'; import 'devextreme-vue/text-area'; import LabelTemplate from './LabelTemplate.vue'; import LabelNotesTemplate from './LabelNotesTemplate.vue'; const employee = service.getEmployee(); const positions = service.getPositions(); const validationRules: Record<string, ValidationRule[]> = { position: [ { type: 'required', message: 'Position is required.' }, ], hireDate: [ { type: 'required', message: 'Hire Date is required.' }, ], }; const nameEditorOptions = { disabled: true }; const positionEditorOptions = { items: positions, searchEnabled: true, value: '' }; const hireDateEditorOptions = { width: '100%', value: null }; const birthDateEditorOptions = { width: '100%', disabled: true }; const notesEditorOptions = { height: 90, maxLength: 200 }; const phoneEditorOptions = { mask: '(X00) 000-0000', maskRules: { X: /[02-9]/ } }; function validateForm(e: DxFormTypes.ContentReadyEvent) { e.component.validate(); } </script>
<template> <div id="template-content"> <i id="helpedInfo" class="dx-icon dx-icon-info" /> Additional <br> {{ data.text }} <DxTooltip target="#helpedInfo" show-event="mouseenter" hide-event="mouseleave" > <template #content> <div id="tooltip-content">This field must not exceed 200 characters</div> </template> </DxTooltip> </div> </template> <script setup lang="ts"> import { DxTooltip } from 'devextreme-vue/tooltip'; withDefaults(defineProps<{ data?: Record<string, any> }>(), { data: () => ({} as Record<string, any>), }); </script> <style scoped> #helpedInfo { color: #42a5f5; } #tooltip-content { font-size: 14px; font-weight: bold; } #template-content { display: inline-flex; } </style>
<template> <div> <i :class="`dx-icon dx-icon-${icon}`"/>{{ data.text }} </div> </template> <script setup lang="ts"> withDefaults(defineProps<{ data?: Record<string, any> icon?: string }>(), { data: () => ({} as Record<string, any>), icon: 'info', }); </script>
window.exports = window.exports || {}; window.config = { transpiler: 'plugin-babel', meta: { '*.vue': { loader: 'vue-loader', }, '*.ts': { loader: 'demo-ts-loader', }, '*.svg': { loader: 'svg-loader', }, 'devextreme/time_zone_utils.js': { 'esModule': true, }, 'devextreme/localization.js': { 'esModule': true, }, 'devextreme/viz/palette.js': { 'esModule': true, }, 'openai': { 'esModule': true, }, }, paths: { 'project:': '../../../../', 'npm:': 'https://cdn.jsdelivr.net/npm/', 'bundles:': '../../../../bundles/', 'externals:': '../../../../bundles/externals/', 'anti-forgery:': '../../../../shared/anti-forgery/', }, map: { 'anti-forgery': 'anti-forgery:fetch-override.js', 'vue': 'npm:vue@3.5.32/dist/vue.esm-browser.js', '@vue/shared': 'npm:@vue/shared@3.4.27/dist/shared.cjs.prod.js', 'vue-loader': 'npm:dx-systemjs-vue-browser@1.1.2/index.js', 'demo-ts-loader': 'project:utils/demo-ts-loader.js', 'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js', 'svg-loader': 'project:utils/svg-loader.js', 'mitt': 'npm:mitt/dist/mitt.umd.js', 'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js', 'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js', 'es6-object-assign': 'npm:es6-object-assign', 'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs', 'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs', 'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js', 'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js', 'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js', 'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js', 'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js', 'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js', 'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js', 'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js', 'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js', 'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js', 'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js', '@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js', 'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js', 'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js', // Prettier 'prettier/standalone': 'npm:prettier@2.8.8/standalone.js', 'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js', }, packages: { 'devextreme-vue': { main: 'index.js', }, 'devextreme-vue/common': { main: 'index.js', }, 'devextreme': { defaultExtension: 'js', }, 'devextreme/events/utils': { main: 'index', }, 'devextreme/common/core/events/utils': { main: 'index', }, 'devextreme/events': { main: 'index', }, 'es6-object-assign': { main: './index.js', defaultExtension: 'js', }, }, packageConfigPaths: [ 'npm:@devextreme/*/package.json', ], babelOptions: { sourceMaps: false, stage0: true, }, }; window.process = { env: { NODE_ENV: 'production', }, }; System.config(window.config); // eslint-disable-next-line const useTgzInCSB = ['openai'];
const employee = { ID: 1, FirstName: 'John', LastName: 'Heart', Position: 'CEO', BirthDate: '1964/03/16', HireDate: '1995/01/15', Notes: 'John has been in the Audio/Video industry since 1990. He has led DevAv as its CEO since 2003.\r\n\r\nWhen not working hard as the CEO, John loves to golf and bowl. He once bowled a perfect game of 300.', Address: '351 S Hill St., Los Angeles, CA', Phone: '360-684-1334', Email: 'jheart@dx-email.com', }; const positions = [ 'HR Manager', 'IT Manager', 'CEO', 'Controller', 'Sales Manager', 'Support Manager', 'Shipping Manager', ]; export default { getEmployee() { return employee; }, getPositions() { return positions; }, };
import { createApp } from 'vue'; import App from './App.vue'; createApp(App).mount('#app');
<!DOCTYPE html> <html lang="en"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" /> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.8/css/dx.light.css" /> <link rel="stylesheet" type="text/css" href="https://maxcdn.bootstrapcdn.com/font-awesome/4.6.3/css/font-awesome.min.css" /> <script src="https://cdn.jsdelivr.net/npm/typescript@5.9.3/lib/typescript.js"></script> <script type="module"> import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js"; window.vueCompilerSFC = vueCompilerSFC; </script> <script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script> <script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script> <script type="text/javascript" src="config.js"></script> <script type="text/javascript"> System.import("./index.ts"); </script> </head> <body class="dx-viewport"> <div class="demo-container"> <div id="app"> </div> </div> </body> </html>

To change the default settings, declare an item configuration object. Use the dataField property to bind an item to a field in the formData object. Use the editorType property to specify an item's data editor or configure the editor in the editorOptions object. You can also specify any other properties described in the SimpleItem section.

To customize item labels, use the label.template property. The demo uses this property to add icons to the labels. Refer to the Additional Notes item's implementation for instructions on how to add an icon with a tooltip to the label.

This demo shows how to specify editorOptions, editorType, validationRules, and colSpan properties for simple items in a Form component.